--KONO DIO DA--

local k_spinouttimer = k_spinouttimer
local k_growshrinktimer = k_growshrinktimer
local k_hyuudorotimer = k_hyuudorotimer
local k_invincibilitytimer = k_invincibilitytimer
local FRACUNIT = FRACUNIT
local DIO_FROZEN = 1<<7

local function shouldHurt(p)
	return not (p.powers[pw_flashing] > 0 or p.kartstuff[k_squishedtimer] > 0 or p.kartstuff[k_spinouttimer] > 0
		or p.kartstuff[k_invincibilitytimer] > 0 or (p.kartstuff[k_growshrinktimer] > 0 or (HugeQuest and p.hugequest.huge)) or p.kartstuff[k_hyudorotimer] > 0 
		or (G_BattleGametype() and ((p.kartstuff[k_bumper] <= 0 and p.kartstuff[k_comebacktimer]) or p.kartstuff[k_comebackmode] == 1)) or p.mo.diofreezetimer > 0)
end

local function shouldBump(p)
	return not (p.kartstuff[k_invincibilitytimer] > 0 or (p.kartstuff[k_growshrinktimer] > 0 or (HugeQuest and p.hugequest.huge)) or p.kartstuff[k_hyudorotimer] > 0)
end

local user = "diobrandopb"

local function freezeTimer(mo)
	if not (mo and mo.valid and mo.player) then return end
	
	mo.diofreezetimer = $ or 0
	
	mo.freezemomx = $ or 0
	mo.freezemomy = $ or 0
	mo.freezemomz = $ or 0
	
	if mo.diofreezetimer
	and not mo.lastfreezetimer then
		-- Store momentum
		mo.freezemomx = mo.momx
		mo.freezemomy = mo.momy
		mo.freezemomz = mo.momz
	end
	
	if mo.diofreezetimer then
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
		mo.color = SKINCOLOR_CYAN
		mo.colorized = true
		mo.diofreezetimer = max ($-1, 0)
		--print(mo.diofreezetimer)
	end
	
	if not mo.diofreezetimer
	and mo.lastfreezetimer then
		--Restore momentum
		mo.momx = mo.freezemomx
		mo.momy = mo.freezemomy
		mo.momz = mo.freezemomz
		
		--Reset frozen values
		mo.freezemomx = 0
		mo.freezemomy = 0
		mo.freezemomz = 0
		mo.player.powers[pw_flashing] = (3*TICRATE)/2
		mo.color = mo.player.skincolor
		mo.colorized = false
	end
	
	
	mo.lastfreezetimer = mo.diofreezetimer
	
	/*
	if mo.diofreezetimer
	or mo.lastfreezetimer then
		print("Current Freeze Timer: "..mo.diofreezetimer)
		print("Previous Freeze Timer: "..mo.lastfreezetimer)
	end
	*/
end
addHook("MobjThinker", freezeTimer, MT_PLAYER)

local function DIOFreeze(mo, timer)
	mo.diofreezetimer = timer
end

local function freezeCollide(mo, mo2)
	if not (mo and mo.valid and mo.player) then return end
	if not (mo2 and mo2.valid and mo2.player) then return end
	
	if (mo.skin == user) -- Only one character should have this
	and not (mo2.skin == mo.skin) 
	and shouldHurt(mo2.player)
	and shouldBump(mo.player)
	and ((mo2.z <= mo.z + mo.height) and (mo2.z + mo2.height >= mo.z)) then -- They're already hurt, no need to dick them over more
		--FREEZE
		DIOFreeze(mo2, 2*TICRATE)
		K_PlayHitEmSound(mo)
	end
end

local function freezeMoveCollide(mo2, mo)
	if not (mo and mo.valid and mo.player) then return end
	if not (mo2 and mo2.valid and mo2.player) then return end
	
	if mo2.skin == user -- Only one character should have this
	and not (mo.skin == mo2.skin) 
	and shouldHurt(mo.player)
	and ((mo2.z <= mo.z + mo.height) and (mo2.z + mo2.height >= mo.z)) then -- They're already hurt, no need to dick them over more
		--FREEZE
		DIOFreeze(mo, 2*TICRATE)
		K_PlayHitEmSound(mo2)
	end
end
addHook("MobjCollide", freezeCollide, MT_PLAYER)
addHook("MobjMoveCollide", freezeMoveCollide, MT_PLAYER)

local function inputFreeze(p, cmd)
	if not p then return end
	
	if cmd.buttons & BT_ATTACK
	and p.mo.diofreezetimer then
		cmd.buttons = ($|DIO_FROZEN) & ~BT_ATTACK
	end
end
addHook("PlayerCmd", inputFreeze)